package listeners;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.testng.IInvokedMethod;
import org.testng.IInvokedMethodListener;
import org.testng.ITestNGMethod;
import org.testng.ITestResult;

import java.nio.file.Path;
import java.nio.file.Paths;

public class ScreenshotListener implements IInvokedMethodListener {
    static Logger LOG = LogManager.getLogger(ScreenshotListener.class);
    Path failureSrc = Paths.get("vwf.jpg");
    Path successSrc = Paths.get("vwb.jpg");

    @Override
    public void beforeInvocation(IInvokedMethod method, ITestResult testResult) {
        LOG.info("Started test");
    }

    @Override
    public void afterInvocation(IInvokedMethod method, ITestResult testResult) {
        ITestNGMethod m = testResult.getMethod();
        String testId = getTestId(m);
        Path scrPath;
        if (testResult.isSuccess()) {
            LOG.info("Test passed {}", testId);
            scrPath = successSrc;
        } else {
            LOG.info("Test failed {}", testId);
            scrPath = failureSrc;
        }
        LOG.info("RP_MESSAGE#FILE#{}#{}", scrPath.toFile().getAbsoluteFile(), "Screenshot " + testId);
    }

    private String getTestId(ITestNGMethod m) {
        return m.getQualifiedName() + "-" + m.getCurrentInvocationCount() + "-" + m.getParameterInvocationCount();
    }
}
